property spriteNum, locs, pos, targetLoc, targetHeight, myState
global robotConstruction, sliderPos

on beginSprite me
  myState = "locked"
  locs = [[82, 94], [177, 111], [291, 262]]
  pos = 1
  sliderPos = 1
  targetLoc = point(sprite(spriteNum).locH, locs[pos][1])
  targetHeight = locs[pos][2]
end

on exitFrame me
  if myState = "Slide" then
    incx = (sprite(spriteNum).loc[1] - targetLoc[1]) / 1.5
    incy = (sprite(spriteNum).loc[2] - targetLoc[2]) / 1.5
    incH = (sprite(spriteNum).height - targetHeight) / 1.5
    sprite(spriteNum).loc = targetLoc + point(incx, incy)
    sprite(spriteNum).height = targetHeight + incH
    if me.distanceCheck(targetLoc, sprite(spriteNum).loc) < 2 then
      sprite(spriteNum).loc = targetLoc
      sprite(spriteNum).height = targetHeight
      sendSprite(13, #updateMaterialFeild, robotConstruction[pos])
      myState = "locked"
    end if
    sendAllSprites(#follow)
  end if
end

on moveMe me, Dir
  sendSprite(13, #updateMaterialFeild, EMPTY)
  if (Dir = "up") and (pos <> 1) then
    puppetSound(1, "sliderMove")
    pos = pos - 1
  end if
  if (Dir = "down") and (pos <> 3) then
    puppetSound(1, "sliderMove")
    pos = pos + 1
  end if
  if (Dir = "left") or (Dir = "right") then
    puppetSound(1, "itemChange")
    changeItem(pos, Dir)
  else
    sliderPos = pos
    targetLoc = point(sprite(spriteNum).locH, locs[pos][1])
    targetHeight = locs[pos][2]
    myState = "Slide"
  end if
end

on NewBrief me
  targetLoc = point(sprite(spriteNum).locH, 260)
  targetHeight = 50
  myState = "Slide"
end

on briefLoaded me
  pos = 1
  sliderPos = 1
  targetLoc = point(sprite(spriteNum).locH, locs[pos][1])
  targetHeight = locs[pos][2]
  myState = "Slide"
end

on distanceCheck me, obj1, obj2
  return sqrt(power(obj1[1] - obj2[1], 2) + power(obj1[2] - obj2[2], 2))
end
