global sectionIDs, BodyHaxis, BodyVaxis, BodyParts, CorrectAnswers, robotConstruction, robotMaterials, briefNumber, briefCount, gCorrectAnswer, gpopUp, glang, gDel, PopUpInfo, briefIds, gMaterialDisplay

on prepareMovie
  if voidp(glang) then
    glang = "cze"
  end if
  gDel = the last char in the pathname
  castLib("text").fileName = the pathname & "langs" & gDel & glang & ".cst"
end

on startMovie
  briefNumber = 0
  briefCount = 0
  briefIds = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]
  BodyHaxis = [422, 532, 642]
  BodyVaxis = [130, 234, 421]
  BodyParts = ["HEAD", "BODY", "LEGS"]
  randomRobotOrder()
  CorrectAnswers = ["Rubber Cork Polystyrene", "Steel", "Copper Steel", "Plastic Rubber", "Steel", "Glass Plastic", "Polystyrene Cork", "Fabric", "Polystyrene Rubber", "Steel Rock"]
  robotMaterials = [EMPTY, "Steel", "Rubber", "Copper", "Plastic", "Steel", "Glass", "Polystyrene", "Fabric", "Rock", "Cork"]
  gMaterialDisplay = robotMaterialDisplay()
  gpopUp = 0
end

on startAgain
  briefNumber = 0
  briefCount = 0
  briefIds = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]
  randomRobotOrder()
  loadNewBrief()
end

on loadText spNum
  sendSprite(spNum, #nextChar)
end

on randomRobotOrder
  sectionIDs = []
  robotIndex = [2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
  repeat with x = 1 to count(BodyParts)
    dupList = duplicate(robotIndex)
    randomOrder = []
    repeat with y = 1 to count(robotIndex)
      r = random(count(dupList))
      append(randomOrder, dupList[r])
      deleteAt(dupList, r)
    end repeat
    addAt(randomOrder, 2, 1)
    sectionIDs[x] = randomOrder
  end repeat
end

on changeItem sec, Dir
  displayOrder = sectionIDs[sec]
  bobyPart = BodyParts[sec]
  if Dir = "left" then
    c = count(displayOrder)
    addAt(displayOrder, 1, displayOrder[c])
    deleteAt(displayOrder, c + 1)
  end if
  if Dir = "right" then
    append(displayOrder, displayOrder[1])
    deleteAt(displayOrder, 1)
  end if
  sectionIDs[sec] = displayOrder
  newOrder = [displayOrder[1], displayOrder[2], displayOrder[3]]
  sendAllSprites(#changeMe, Dir, bobyPart, newOrder)
end

on NextBrief
  randomRobotOrder()
  loadNewBrief()
  sendAllSprites(#resetDefault)
end

on loadNewBrief
  robotConstruction = [EMPTY, EMPTY, EMPTY]
  briefCount = briefCount + 1
  if briefCount <= 10 then
    r = random(count(briefIds))
    bID = briefIds[r]
    deleteAt(briefIds, r)
    briefNumber = bID
    gCorrectAnswer = CorrectAnswers[briefNumber]
    sendAllSprites(#NewBrief)
  else
    sendAllSprites(#popup, 3, "taskComplete")
  end if
end

on testRobot showAnswer
  if showAnswer then
    alert("Answer:" && gCorrectAnswer)
  else
    if getPos(robotConstruction, EMPTY) = 0 then
      killRobot = 0
      repeat with x = 1 to count(robotConstruction)
        Ok = gCorrectAnswer contains robotConstruction[x]
        killRobot = killRobot + Ok
      end repeat
      if killRobot < 3 then
        sendAllSprites(#popup, 3, "wrong")
      else
        sendAllSprites(#popup, 3, "correct")
      end if
    else
    end if
  end if
end
